<?php
/**
 *  QQ:2420355482   51助手网(www.51zuso.com)
 */
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

//error_reporting(E_ALL);
global $_G;
//插件地址
$pluginPath = $_G['siteurl'].ADMINSCRIPT.'?action=plugins&operation=config&identifier=zuso_help';

//文章列表
function articleLst($page,$length){
	$sNum = ($page-1)*$length;
	$list = DB::fetch_all('SELECT * FROM %t  ORDER BY sort ASC, id DESC LIMIT '.$sNum.','.$length,array('zuso_help'));
	$classify = classifyLst();
	$temp = array();
	foreach($classify as $ck=>$cv){
		$temp[$cv['id']] = $cv['name'];
	}
	foreach($list as $k=>$v){
		$v['cname'] = $temp[$v['cid']];
		$list[$k] = $v;
	}
	
	$res = array();
	$res['list'] = $list;
	
	//分页
	$pageList = array();
	$count = DB::fetch_all('SELECT COUNT(id) FROM %t',array('zuso_help'))[0]["COUNT(id)"];
	$res['page'] = paginate($count,$page,$length);
	return $res;
}

//文章排序
function articleSort($data){
	foreach($data as $k=>$v){
		DB::update('zuso_help', $v, array('id' => $k)); 
	}
	return true;
}

//文章添加
function articleAdd($data){
	$res = DB::insert('zuso_help',$data);
	return $res;
}

//文章删除
function articleDel($id){
	$res = DB::delete('zuso_help',array('id'=>$id),1,true);
	return $res;
}

//文章读取
function articleShow($id){
	$data = DB::fetch_first('SELECT * FROM %t WHERE id=%d',array('zuso_help',$id));
	return $data;
}

//文章更新
function articleUpd($data){
	$res = DB::update('zuso_help',$data, array('id'=>$data['id'])); 
	return $res;
}



//分类列表
function classifyLst(){
	
	global $_G;
	loadcache('classifyLst');
	if($_G['cache']['classifyLst']){
		return $_G['cache']['classifyLst'];
	}
	
	$res = DB::fetch_all('SELECT * FROM %t ORDER BY sort ASC',array('zuso_help_classify'));
	$temp = array();
	$res  = sorts($res);
	foreach($res as $k=>$v){
		$temp[$v['id']] = $v;
	}
	
	savecache('classifyLst',$temp);
	return $temp;
}

//添加分类
function addClassify($data){
	savecache('classifyLst',null);
	if($data['icon'] != ''){
		if(preg_match('/^data:image/',$data['icon'])){
			$data['icon'] = base64Img($data['icon'],'source/plugin/zuso_help/static/upload/');
		}
	}
	
	return DB::insert('zuso_help_classify',$data);
}

//分类排序
function sortClassify($data){
	foreach($data as $k=>$v){
		DB::update('zuso_help_classify', $v, array('id' => $k)); 
	}
	savecache('classifyLst',null);
	return true;
}

//删除分类
function delClassify($id){
	DB::delete('zuso_help_classify',array('id'=>$id),1,true);
	DB::update('zuso_help_classify',array('pid'=>0,'level'=>1), array('pid' => $id)); 
	savecache('classifyLst',null);
	return true;
}

//读取一条分类数据
function getClassify($id){
	$data = DB::fetch_first('SELECT * FROM %t WHERE id=%d',array('zuso_help_classify',$id));
	return $data;
}

//更新分类
function updateClassify($data){
	if($data['icon'] != ''){
		if(preg_match('/^data:image/',$data['icon'])){
			$data['icon'] = base64Img($data['icon'],'source/plugin/zuso_help/static/upload/');
		}
	}
	
	
	
	$res = DB::update('zuso_help_classify',$data, array('id'=>$data['id'])); 
	savecache('classifyLst',null);
	return $res;
}


//分类树
function classTree(){
	$classify = classifyLst();
	
	$tree = array();
	foreach($classify as $k=>$v){
		if($v['level'] == 1){
			$tree[] = $v;
		}
	}
	foreach($tree as $k=>$v){
		foreach($classify as $ck=>$cv){
			if($cv['pid'] == $v['id']){
				$v['child'][] = $cv;
			}
		}
		$tree[$k] = $v;
	}
	
	$temp = array();
	foreach($tree as $k=>$v){
		
		$temp[$v['id']] = $v;
		
	}
	$tree = $temp;
	return $tree;
}

//分类文章显示
function classArt($cid,$aid,$keyword,$page,$length){
	$res = array();
	
	//文章显示
	if($aid){
		$res = array();
		$res['type'] = 'show';
		$res['list'] = DB::fetch_first('SELECT * FROM %t WHERE id=%d',array('zuso_help',$aid));
		countHit($aid,$res['list']['hit']);
		return $res;
	}
	
	//搜索
	if($keyword){
		$keyword = '%'.$keyword.'%';
		$res['type'] = 'list';
		$sNum = ($page-1)*$length;
		$res['list'] = DB::fetch_all("SELECT * FROM %t WHERE title like '%i' AND status=1 LIMIT ".$sNum.",".$length,array('zuso_help',$keyword));
		
		
		//分页
		$pageList = array();
		$count = DB::fetch_all("SELECT COUNT(id) FROM %t WHERE title like '%i' AND status=1",array('zuso_help',$keyword))[0]["COUNT(id)"];
		$res['page'] = paginate($count,$page,$length);
		
		return $res;
	}
	
	
	//cid
	if($cid){
		$classify = classifyLst();
		$cids = $cid;
		foreach($classify as $k=>$v){
			if($v['pid'] == $cid){
				$cids .=','.$v['id'];
			}
		}
			
		$res['type'] = 'list';
		$sNum = ($page-1)*$length;
		$res['list'] = DB::fetch_all('SELECT * FROM %t WHERE cid in (%i) AND status=1 ORDER BY rec ASC,sort ASC LIMIT '.$sNum.','.$length,array('zuso_help',$cids));
		
		//当只为一篇文章时
		if(count($res['list']) == 1){
			$res['type'] = 'show';
			$res['list'] = $res['list'][0];
			countHit($res['list']['id'],$res['list']['hit']);
			return $res;
		}
		
		
		//分页
		$count = DB::fetch_all('SELECT COUNT(id) FROM %t WHERE cid in (%i) AND status=1',array('zuso_help',$cid))[0]["COUNT(id)"];
		$res['page'] = paginate($count,$page,$length);
		
		return $res;
	}
	
	$res['type'] = 'list';
	$sNum = ($page-1)*$length;
	$res['list'] = DB::fetch_all('SELECT * FROM %t WHERE status=1 ORDER BY sort ASC  LIMIT '.$sNum.','.$length,array('zuso_help'));
	//分页
	$count = DB::fetch_all('SELECT COUNT(id) FROM %t',array('zuso_help'))[0]["COUNT(id)"];
	$res['page'] = paginate($count,$page,$length);
	
	return $res;
}


//分页
function paginate($count,$page,$length){
	$pageList = array();
	$pageList['num'] = $page; //页数
	$pageList['quantity'] = ceil($count/$length); //分页数量
	$pageList['count'] = $count; //总条数
	$page>1?$pageList['prev'] = $page-1:$pageList['prev']= null; //上一页
	$page<$pageList['quantity']? $pageList['next'] = $page+1 : $pageList['next']= null; //下一页
	
	$i = 1;
	while($i<=$pageList['quantity']){
		$pageList['pageArr'][] = $i;
		$i++;
	}
	return $pageList;
}



//点击统计
function countHit($id,$hit){
	DB::query('update %t set hit=%d where id=%d', array('zuso_help',$hit+1,$id));
}

//当前位置
function getMap($cid){
	$map = array();
	if(!$cid){
		return $map;
	}
	
	$classify = classifyLst();
	$temp = array();
	foreach($classify as $k=>$v){
		$temp[$v['id']] = $v;
	}
	
	if($temp[$cid]['level'] >1){
		$map[] = $temp[$temp[$cid]['pid']];
		$map[] = $temp[$cid];
	}else{
		$map[] = $temp[$cid];
	}
	return $map;
}

//子级排序
function sorts($data,$pid=0){
	static $arr = array();
	foreach ($data as $k => $v) {
		if($v['pid'] == $pid){
			$arr[]=$v;
			sorts($data,$v['id']);
		}
	}
	return $arr;
}

//判断是否为手机
function is_mobile(){
    $regex_match="/(nokia|iphone|android|motorola|^mot\-|softbank|foma|docomo|kddi|up\.browser|up\.link|";
    $regex_match.="htc|dopod|blazer|netfront|helio|hosin|huawei|novarra|CoolPad|webos|techfaith|palmsource|";
    $regex_match.="blackberry|alcatel|amoi|ktouch|nexian|samsung|^sam\-|s[cg]h|^lge|ericsson|philips|sagem|wellcom|bunjalloo|maui|";   
    $regex_match.="symbian|smartphone|midp|wap|phone|windows ce|iemobile|^spice|^bird|^zte\-|longcos|pantech|gionee|^sie\-|portalmmm|";
    $regex_match.="jig\s browser|hiptop|^ucweb|^benq|haier|^lct|opera\s*mobi|opera\*mini|320x320|240x320|176x220";
    $regex_match.=")/i";       
    return isset($_SERVER['HTTP_X_WAP_PROFILE']) or isset($_SERVER['HTTP_PROFILE']) or preg_match($regex_match, strtolower($_SERVER['HTTP_USER_AGENT']));
}


//存储图片
//base64_image_content base64图片
//path 存储路径
function base64Img($base64_image_content,$path){
	//匹配出图片的格式
	if (preg_match('/^(data:\s*image\/(\w+);base64,)/', $base64_image_content, $result)){
		$type = $result[2];
		$new_file = $path;
		
		//验证图片格式
		$allImg = array('gif','bmp','png','ico','jpg','jpeg','svg');
		if(!in_array($type,$allImg)) return false;
		if($type == 'jpeg'){$type = 'jpg';}
		
		if(!file_exists($new_file)){
			//检查是否有该文件夹，如果没有就创建，并给予最高权限
			mkdir($new_file, 0700);
		}
		$new_file = $new_file.uniqid().'.'.$type;
		if (file_put_contents($new_file, base64_decode(str_replace($result[1], '', $base64_image_content)))){
			return $new_file;
		}else{
			return false;
		}
	}else{
		return false;
	}
}

?>